<?php
// Copyright (C) 2001, 2002 Lluis Gesa
//
// This file is part of WePS.
//
// WePS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// WePS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with WePS; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
?>
<?php
// $Id: createrepository.php,v 1.7 2002/08/24 10:01:24 aleix Exp $
?>
<?php
  require("inc/init_env.php");

  $TITLE = _my("Repository tools");

  if (isset($createButton))
  {
    $num_dirs = 0;
    $num_files = 0;
    if (isset($build_dirs))
    {
      $query = $db->exec("select * from category order by fullname");
      $n = $db->numrows($query);
      if ($n > 0)
      {
        for($i = 0; $i < $n; $i++)
        {
          $obj = $db->fetch_object($query, $i);
          $dir = $config["path"]["REPOSITORY_PATH"] . "/" . str_replace($config["misc"]["CATEGORY_SEPARATOR"], "/", $obj->fullname);
          if (!@is_dir ($dir)) 
          {
            @mkdir($dir, 0755);
            $num_dirs ++;
          }
          $query2 = $db->exec("select * from package where cat_id=$obj->id order by name");
          $n2 = $db->numrows($query2);
          if ($n2 > 0)
          {
            for($j = 0; $j < $n2; $j++)
            {
              $obj2 = $db->fetch_object($query2, $j);
              $dir = $config["path"]["REPOSITORY_PATH"] . "/" . str_replace($config["misc"]["CATEGORY_SEPARATOR"], "/", $obj->fullname)."/".$obj2->name;
              if (!@is_dir ($dir)) 
              {
                @mkdir($dir, 0755);
                $num_dirs ++;
              }
            }
          }
        }
      }
    }
    if (isset($erase_files))
    {
      $query = $db->exec("select * from file");
      $n = $db->numrows($query);
      if ($n > 0)
      {
        for($i = 0; $i < $n; $i++)
        {
          $obj = $db->fetch_object($query, $i);
          $query2 = $db->exec("select * from package where id=$obj->pac_id");     
          $n2 = $db->numrows($query2);
          if ($n2 > 0)
          {
            $obj2 = $db->fetch_object($query2, 0);
            $query3 = $db->exec("select * from category where id=$obj2->cat_id");     
            $n3 = $db->numrows($query2);
            if ($n2 > 0)
            {
              $obj3 = $db->fetch_object($query3, 0);
              $dir = $config["path"]["REPOSITORY_PATH"] . "/" . str_replace($config["misc"]["CATEGORY_SEPARATOR"], "/", $obj3->fullname)
                     . "/". $obj2->name . "/" . $obj->name;
              if (!file_exists ($dir))
              {
                $db->exec("delete from file where id=$obj->id");
                $num_files ++;
              }
            }
         }
        }
      }
    }
  }
?>
<table width="100%" border="0" cellpadding="0" cellspacing="0">
  <tr align="LEFT" valign="TOP">
    <td><img src="img/dot.png" width="4" height="15"></td>
  </tr>
  <tr align="LEFT" valign="TOP" class="maintitle">
    <td>
      <b><font class="maintitle"><?= $TITLE ?></font></b>
    </td>
  </tr>
  <tr><td>&nbsp;</td></tr>
  <tr>
    <td> 
      <table border="0" width="90%">
        <?php  $link = create_weps_link($config["action"]["dispatcher"],"createrepository"); ?>
        <form name="form1" method="post" action="<?= $link ?>">
          <tr class="file">
            <td width="2%"><input type="checkbox" name="build_dirs" value="check"></td>
            <td><?= _my("Synchronize repository using database information") ?> </td>
          </tr>
          <tr class="file">
            <td><input type="checkbox" name="erase_files" value="check"></td>
            <td><?= _my("Synchronize database files using repository information") ?></td>
          </tr>
          <tr>
            <td>&nbsp;</td>
            <?php
              echo '<td align="center"><input type="submit" name="createButton" value="';
              echo _my("Execute");
              echo '"><td>' . "\n";
            ?>
          </tr>
        </form>
      </table>
    </td>
  </tr>
  <tr>
    <td>
      <?php 
        if (isset($createButton))
        {
          echo '<br><p><b><font class="topcategory">';
          echo _my("Here is a list of taken actions:");
          echo '</font></b></p>' . "\n";
          echo sprintf(_my("%d directories created."), $num_dirs);
          echo '<br>' . "\n";
          echo sprintf(_my("%d file(s) deleted from database table."), $num_files);
        }
      ?>
      </table>
    </td>
   </tr>
</table>
<?php
  require("inc/close_env.php");
?>
